﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Web.UI;
using System.ComponentModel;
using System.Reflection;

namespace ContainerManager {
    internal static class ControlExtensions {
        internal static Control SetEvents(this Control ctrl, EventHandlerList events) {
            ControlHelper.SetEvents(ctrl, events);
            return ctrl;
        }
    }

    internal class ControlHelper {
        internal static bool SetEvents(Control ctrl, EventHandlerList events) {
            bool hasSet = false;
            System.Reflection.PropertyInfo[] properties = typeof(Control).GetProperties(
                BindingFlags.NonPublic | BindingFlags.Instance);
            foreach (PropertyInfo pi in properties) {
                object o = pi.GetValue(ctrl, null);
                if (o is EventHandlerList) {
                    EventHandlerList es = o as EventHandlerList;
                    if (es != null) {
                        EventHandlerList ehl;
                        Copy(events, out ehl);

                        es.AddHandlers(ehl);
                        hasSet = true;
                    }
                    break;
                }
            }
            return hasSet;
        }

        internal static void Copy(EventHandlerList source, out EventHandlerList target) {
            target = new EventHandlerList();
            target.AddHandlers(source);
        }
    }
}
