﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Xml.Linq;
using System.Web.UI;

namespace ContainerManager
{
    public class ICollectionHistoryFactory<U> where U : new()
    {
        public static ICollectionHistroy<U> CreateInstance(object storage)
        {
            if (storage is System.Web.Caching.Cache)
            {
                return new WebCacheHistroyManager<U>(storage);
            }
            else if (storage is StateBag)
            {
                return new StateBagHistoryManager<U>(storage);
            }
            else if (storage is System.Web.SessionState.HttpSessionState)
            {
                return new SessionHistoryManager<U>(storage);
            }
            else
            {
                return new WebCacheHistroyManager<U>(storage);
            }
        }
    }
}
