﻿using System;
using System.Data;
using System.Configuration;
using System.Linq;
using System.Web;
using System.Collections.Generic;

namespace ContainerManager
{
    public class SessionHistoryManager<U> : StoreHistroyManager<U> where U : new()
    {
        public SessionHistoryManager() { }
        public SessionHistoryManager(object storage)
        {
            _storage = storage;
        }

        #region ICollectionHistroy<U> 成员

        public override void Add(string key, U u)
        {
            (_storage as System.Web.SessionState.HttpSessionState).Add(key, u);
        }

        public override U Histroy(string key)
        {
            System.Web.SessionState.HttpSessionState cache = _storage as System.Web.SessionState.HttpSessionState;
            return cache[key] == null ? new U() : (U)cache[key];
        }

        public override bool ContainsKey(string key)
        { 
            System.Web.SessionState.HttpSessionState cache = _storage as System.Web.SessionState.HttpSessionState;
            return cache[key] != null;
        }

        public override void Remove(string key)
        {
            (_storage as System.Web.SessionState.HttpSessionState).Remove(key);
        }

        #endregion
    }
}
