﻿using System;
using System.Collections;
using System.Configuration;
using System.Data;
using System.Linq;
using System.Web;
using System.Web.Security;
using System.Web.UI;
using System.Web.UI.HtmlControls;
using System.Web.UI.WebControls;
using System.Web.UI.WebControls.WebParts;
using System.Xml.Linq;
using System.Web.UI.MobileControls;
using System.Collections.Generic;
using System.Runtime.Serialization;
using ContainerManager;
using System.ComponentModel;

namespace WebAppPlaceHolder {
    public partial class _Default : System.Web.UI.Page {
        public ContainerManager.ContainerManager cm = new ContainerManager.ContainerManager();

        protected void Page_Load(object sender, EventArgs e) {
            //重载控件(Session作为存储介质)
            cm.ReloadControls(this.Session, "PlaceHolder_DynamicUserControlContainer", PlaceHolder_DynamicUserControlContainer.Controls, this.Events);
            
            //重载控件(HttpContext.Current.Cache作为存储介质)
            cm.ReloadControls(HttpContext.Current.Cache, "PlaceHolder_DynamicUserControlContainer", PlaceHolder_DynamicUserControlContainer.Controls, this.Events);
        }

        protected void btnInsertDynamicUserControl_Click(object sender, EventArgs e) {
            //Control c1 = LoadControl("DynamicUserControl.ascx");
            //PlaceHolder_DynamicUserControlContainer.Controls.Add(c1);

            int displayCount;
            int.TryParse(txtNumber.Text, out displayCount);
            if (displayCount == 0) {
                //追加控件(Session作为存储介质)
                Control c1 = LoadControl("DynamicUserControl.ascx");
                cm.AppendControl(this.Session, "PlaceHolder_DynamicUserControlContainer", PlaceHolder_DynamicUserControlContainer.Controls, c1);
            }
            else if (displayCount == 1) {
                //追加控件(HttpContext.Current.Cache作为存储介质)
                Control c1 = LoadControl("DynamicUserControl.ascx");
                Control c2 = LoadControl("WebUserControl.ascx");
                cm.AppendControl(HttpContext.Current.Cache, "PlaceHolder_DynamicUserControlContainer", PlaceHolder_DynamicUserControlContainer.Controls, c1);
                cm.AppendControl(HttpContext.Current.Cache, "PlaceHolder_DynamicUserControlContainer", PlaceHolder_DynamicUserControlContainer.Controls, c2);
            }
            else {
                //常见的动态加载控件后点击其他回发事件就导致控件丢失
                PlaceHolder_DynamicUserControlContainer.Controls.Clear();
                Control c1 = LoadControl("DynamicUserControl.ascx");
                PlaceHolder_DynamicUserControlContainer.Controls.Add(c1);
                cm.CacheControls(HttpContext.Current.Cache, "PlaceHolder_DynamicUserControlContainer", PlaceHolder_DynamicUserControlContainer.Controls);
            }
        }

        protected void btnUnloadStorage_Click(object sender, EventArgs e) {
            cm.Remove(HttpContext.Current.Cache, "PlaceHolder_DynamicUserControlContainer");
        }
    }
}
